// Simple blinking led program for the LPC-P2148 board

/* *********************************************************
               Function declarations
  ********************************************************* */

void Initialize(void);
void feed(void);
void putch(char);

void IRQ_Routine (void)   __attribute__ ((interrupt("IRQ")));
void FIQ_Routine (void)   __attribute__ ((interrupt("FIQ")));
void SWI_Routine (void)   __attribute__ ((interrupt("SWI")));
void UNDEF_Routine (void) __attribute__ ((interrupt("UNDEF")));

/**********************************************************
                  Header files
 **********************************************************/
#include "LPC2148.h"

/**********************************************************
                       MAIN
**********************************************************/
char buf1[] = "Finally! a message from C code. Yayyy!!!\r\n";
char c;
int ndx = 0;
int len1 = 42;

int main (void) {
  int j;              // loop counter (stack variable)

  Initialize();		
	
  //IO0DIR |= 0x00000c00;	// P0.10 & P0.11 output
  //IO0SET =  0x00000c00;
 
	
  // endless loop to toggle the two leds
  while (1) {
		
    for (j = 32768; j > 0; j-- );		// wait
    ndx++;
    if (ndx >= len1) {ndx = 0;} 
    putch(buf1[ndx]);
    //IO0SET = 0x00000800;
    //IO0CLR = 0x00000400;	
    //for (j = 32768; j > 0; j-- );		// wait
    //IO0SET = 0x00000400;
    //IO0CLR = 0x00000800;		
  }
}

#define PLOCK 0x400
#define THRE 0x20

void putch(char x){
  while (! (U0LSR & THRE)){}
  U0THR = x;
} 

/**********************************************************
                      Initialize
**********************************************************/

void Initialize(void)  {  
  // Setting Multiplier and Divider values
  // Fosc = 12MHz; M = 5; cclk = 60Mhz
  // P = 2; Fcco = cclk * 2 * P = 240 Mhz
  //PLL0CFG=0x24;
  //feed();
  
  // Enabling the PLL */
  //PLL0CON=0x1;
  //feed();
  
  // Wait for the PLL to lock to set frequency
  //while(!(PLL0STAT & PLOCK)) ;
  
  // Connect the PLL as the clock source
  //PLL0CON=0x3;
  //feed();
  
  // Enabling MAM and setting number of clocks used for Flash memory fetch (4 cclks in this case)
  //MAMCR=0x2;
  //MAMTIM=0x4;
  
  // Setting peripheral Clock (pclk) to System Clock (cclk)
  // (hfs) seems a LOT safer to leave it at divide by 4
  //VPBDIV=0x1; --> Pclk = 15 MHz
  //Set P0.0,1 as UART, 9600
  PINSEL0 = 0x05;
  //3MHz / 16 / 4800 = 39.06 --> try 39
  U0LCR = 0x83; //8N1, enable divisor latch
  U0DLL = 39;
  U0LCR = 0x03; //8N1; disable divisor latch
}

void feed(void)
{
  PLL0FEED=0xAA;
  PLL0FEED=0x55;
}

/*  Stubs for various interrupts (may be replaced later)  */
/*  ----------------------------------------------------  */

void IRQ_Routine (void) {
	while (1) ;	
}

void FIQ_Routine (void)  {
	while (1) ;	
}


void SWI_Routine (void)  {
	while (1) ;	
}


void UNDEF_Routine (void) {
	while (1) ;	
}
